Attribute VB_Name = "RandomDataSource"
Option Explicit

' Constants which tell the random price generator the start and end times of the data (i.e. market open/close)
Public Const RandomDataStartTime = 8   ' 8 am data start
Public Const RandomDataEndTime = 20    ' 8 pm data end

Public CloseVal As Double
Public OpenVal As Double
Public HighVal As Double
Public LowVal As Double
Public VolVal As Double

Public Sub GetNextPriceBar()
    ' This procedure randomly generates price bars (OpenVal, HighVal, LowVal, CloseVal and VolVal)
    ' In a real application, this procedure would get the next historical price bar from the data feed
    
    Dim totalvol As Single
    Dim i As Long
    
    For i = 1 To 20    ' assume 20 ticks per bar for simulation purposes
        GetNextTick
        
        If i = 1 Then
            OpenVal = CloseVal
            HighVal = CloseVal
            LowVal = CloseVal
        Else
            If CloseVal > HighVal Then HighVal = CloseVal
            If CloseVal < LowVal Then LowVal = CloseVal
        End If
        totalvol = totalvol + VolVal
    Next i
    VolVal = totalvol
End Sub

Public Sub GetNextTick()
    ' This procedure randomly generates tick bars (CloseVal and VolVal).
    ' In a real application, this procedure would get the next tick bar from the data feed
    
    If Rnd() > 0.49 Then  ' slight upward TimeZoneBias to generating up ticks
        CloseVal = CloseVal + 0.01
    Else
        CloseVal = CloseVal - 0.01
    End If
    CloseVal = Round(CloseVal, 2)
    VolVal = CLng(Rnd() * 5000)
End Sub



